import logging

from portal.async import celery_app
from portal.async.helpers import reset_task_id
from portal.database.models import Submission, SubmissionState

log = logging.getLogger(__name__)


def submission_store_ended(submission: Submission):
    # TODO: TBD
    log.info(f"[ASYNC] Submission preparation ended: {submission}")
    reset_task_id(submission=submission, task_id_type='storage_task_id',
                  state=SubmissionState.READY)


def revoke_storage_task(submission: Submission):
    log.info(f'[ASYNC] Submission storage upload cancelled {submission}')
    task_id = submission.storage_task_id
    if task_id:
        celery_app.control.revoke(task_id=task_id, terminate=True)
        reset_task_id(submission=submission, task_id_type='storage_task_id',
                      state=SubmissionState.CANCELLED)
    # TODO: Dispatch cleanup task
