"""
A collection of Mixins specifying common behaviour and attributes of database entities.
"""

from portal import db


# maybe use server_default, server_onupdate instead of default, onupdate; crashes tests
# (https://stackoverflow.com/questions/13370317/sqlalchemy-default-datetime)
# pylint: disable=too-few-public-methods
class EntityBase(object):
    """Entity mixin for the models
    Attributes:
        created_at(Column): Date when the entity has been created
        updated_at(Column): Date when the entity has been updated
    """
    EXCLUDED = []
    created_at = db.Column(db.TIMESTAMP, default=db.func.now())
    updated_at = db.Column(
        db.TIMESTAMP, default=db.func.now(), onupdate=db.func.now())
# pylint: enable=too-few-public-methods
