import os
import pytest

from management.data import DataManagement
from portal import create_app, db
from portal.logging import load_config

load_config('test')


@pytest.fixture(scope='function')
def app():
    os.environ["PORTAL_CONFIG_TYPE"] = 'test'
    flask_app = create_app(environment='test')
    from tests import init_db
    init_db(flask_app)
    with flask_app.app_context():
        DataManagement(flask_app, db).create_admin_user('admin', '789789')
        DataManagement(flask_app, db).init_data('test')
        yield flask_app
        db.session.remove()
        db.drop_all()


@pytest.fixture(scope='function')
def client(app):
    with app.test_client() as _client:
        yield _client
